texture vd_srctexture;
float4 vd_texsize;

sampler src = sampler_state {
	Texture = <vd_srctexture>;
	AddressU = clamp;
	AddressV = clamp;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = None;
};

void VS(
	float4 pos : POSITION,
	float2 t0 : TEXCOORD0,
	out float4 oPos : POSITION,
	out float2 oT0 : TEXCOORD0
)
{
	oPos = pos;
	oT0 = t0;
}

float4 PS(float2 uv : TEXCOORD0) : COLOR0 {
   float4 B = tex2D(src, uv);
   float A = dot(float3(1.0/3.0, 1.0/3.0, 1.0/3.0), B.rgb);
   
   float a = 6;
   float b = 3;
   
   float y = 1 / (1 + exp(a / 2));
   float z = 1 / (1 + exp(b / 2));
   
   float4 C;

	A = (A + 0.1) / 1.4;
	B = (B + 0.2) / 1.4;

	B.r = pow(B.r, 1.1);
	B.g = pow(B.g, 1.00);

	B = pow(B, 0.8);

	B.r = (1 /(1 + exp(- a * (B.r - .5))) - y)/(1 - 2 * y);
	B.g = (1 /(1 + exp(- b * (B.g - .5))) - z)/(1 - 2 * z);

   	if (A < 0.5)
		C = 2 * A * B;
   
   	else
		C = 1 - 2 * (1 - A) * (1 - B);

   return C;
}

technique {
	pass {
		VertexShader = compile vs_2_a VS();
		PixelShader = compile ps_2_a PS();
	}
}
