texture vd_srctexture;
float4 vd_texsize;

sampler src = sampler_state {
	Texture = <vd_srctexture>;
	AddressU = clamp;
	AddressV = clamp;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = None;
};

void VS(
	float4 pos : POSITION,
	float2 t0 : TEXCOORD0,
	out float4 oPos : POSITION,
	out float2 oT0 : TEXCOORD0,
	out float2 oT1 : TEXCOORD1,
	out float2 oT2 : TEXCOORD2,
	out float2 oT3 : TEXCOORD3,
	out float2 oT4 : TEXCOORD4
)
{
	oPos = pos;
	oT0 = t0 + float2( 0.0f,  0.0f) * vd_texsize.wz;
	oT1 = t0 + float2( 0.0f, -1.2f) * vd_texsize.wz;
	oT2 = t0 + float2( 0.0f,  1.2f) * vd_texsize.wz;
	oT3 = t0 + float2(-1.2f,  0.0f) * vd_texsize.wz;
	oT4 = t0 + float2( 1.2f,  0.0f) * vd_texsize.wz;
}

float4 PS(
	float2 t0 : TEXCOORD0,
	float2 t1 : TEXCOORD1,
	float2 t2 : TEXCOORD2,
	float2 t3 : TEXCOORD3,
	float2 t4 : TEXCOORD4
) : COLOR0
{
	float4 p0 = tex2D(src, t0);
	float4 p1 = tex2D(src, t1);
	float4 p2 = tex2D(src, t2);
	float4 p3 = tex2D(src, t3);
	float4 p4 = tex2D(src, t4);
	float4 p5 = tex2D(src, float2(t3.x, t1.y));
	float4 p6 = tex2D(src, float2(t4.x, t1.y));
	float4 p7 = tex2D(src, float2(t3.x, t2.y));
	float4 p8 = tex2D(src, float2(t4.x, t2.y));

	return    p0 * (36.0f / 256.0f)
		+ p1 * (30.0f / 256.0f)
		+ p2 * (30.0f / 256.0f)
		+ p3 * (30.0f / 256.0f)
		+ p4 * (30.0f / 256.0f)
		+ p5 * (25.0f / 256.0f)
		+ p6 * (25.0f / 256.0f)
		+ p7 * (25.0f / 256.0f)
		+ p8 * (25.0f / 256.0f)
		;
}

technique {
	pass {
		VertexShader = compile vs_2_0 VS();
		PixelShader = compile ps_2_0 PS();
	}
}
